(function ($, Drupal) {
  Drupal.behaviors.chat = {
    attach: function (context, settings) {
      $("#pass-chat-btn").click(function(){
        sessionToken = Drupal.behaviors.chat.token();

        sessionToken.then(
          token => {
            $.ajax('/rest/chat?op=operators-list', {
              headers: {
                'Content-Type': 'application/json',
                'X-CSRF-Token': token,
              },
              dataType: 'json',
              type: 'POST',
              contentType: 'application/json',
              success: function(data) {
                var select = $('<select>', {
                  'id': 'switched-operator',
                  'class': 'form-select w-auto'
                });
                var option = $('<option>', {
                  'value': ''
                });
                option.html('Выберите оператора');
                select.append(option);
                $.each(data, function(i, v){
                  var option = $('<option>', {
                    'value': i
                  });
                  option.html(v);
                  select.append(option);
                });

                $("#switch-operator-wrapper").html(select[0].outerHTML);
                $("#pass-chat-btn").hide();
                $("#switch-operator-wrapper").show();
                $("#switched-operator").change(function(){
                  sessionToken = Drupal.behaviors.chat.token();
                  var uid = $("#switched-operator").val();
                  sessionToken.then(
                    token => {
                      $.ajax('/rest/chat?op=switch-operator', {
                        data: JSON.stringify({
                          chat_id: $("#msgs-wrapper").data("chat_id"),
                          uid: uid
                        }),
                        headers: {
                          'Content-Type': 'application/json',
                          'X-CSRF-Token': token,
                        },
                        dataType: 'json',
                        type: 'POST',
                        contentType: 'application/json',
                        success: function(data) {
                          Drupal.behaviors.chat.refreshChatsList();
                        }
                      });
                    },
                  );
                  $("#switch-operator-wrapper").hide();
                  $("#pass-chat-btn").show();
                });

                // Swal.fire({
                //   title: 'Кому передать чат?',
                //   type: 'question',
                //   html: select[0].outerHTML,
                //   showCloseButton: true,
                //   showCancelButton: true,
                //   focusConfirm: false,
                //   confirmButtonText: 'Передать',
                //   cancelButtonText: 'Отмена',
                // }).then((result) => {
                //   if (result.value) {
                //     sessionToken = Drupal.behaviors.chat.token();
                //     var uid = $("#switched-operator").val();
                //     sessionToken.then(
                //       token => {
                //         $.ajax('/rest/chat?op=switch-operator', {
                //           data: JSON.stringify({
                //             chat_id: $("#msgs-wrapper").data("chat_id"),
                //             uid: uid
                //           }),
                //           headers: {
                //             'Content-Type': 'application/json',
                //             'X-CSRF-Token': token,
                //           },
                //           dataType: 'json',
                //           type: 'POST',
                //           contentType: 'application/json',
                //           success: function(data) {
                //             Drupal.behaviors.chat.refreshChatsList();
                //           }
                //         });
                //       },
                //     );
                //   }
                // });
              }
            });
          },
        );

      });

      $("#close-chat-btn").click(function(){
        $("#close-chat-btn").hide();
        sessionToken = Drupal.behaviors.chat.token();

        sessionToken.then(
          token => {
            $.ajax('/rest/chat?op=close', {
              data: JSON.stringify({
                id: $("#msgs-wrapper").data("chat_id")
              }),
              headers: {
                'Content-Type': 'application/json',
                'X-CSRF-Token': token,
              },
              dataType: 'json',
              type: 'POST',
              contentType: 'application/json',
              success: function(data) {
                Drupal.behaviors.chat.refreshChatsList();
              }
            });
          },
        );
      });
      $(".ms-chat-toggle").click(function(){
        Drupal.behaviors.chat.showChat();
        $(".trinion-chat .card").show();
        $(".trinion-chat").addClass('open');
      });
      $(".ms-chat-close").click(function(){
        $(".trinion-chat .card").hide();
        $(".trinion-chat").removeClass('open');
      });

      // if( $('.ms-scrollable').length > 0 ){
      //   $('.ms-scrollable').each(function(){
      //     var ps = new PerfectScrollbar($(this)[0], {
      //       maxScrollbarLength : 700,
      //       wheelPropagation : true
      //     });
      //   });
      // }

      $("#send-msg").click(function(){
        sendMsg();
        $(".ms-chat-panel textarea").val('');
      });

      $(".change-chat-status").change(function (e) {
        sessionToken = Drupal.behaviors.chat.token();

        sessionToken.then(
          token => {
            $.ajax('/rest/chat?op=change-operator-status', {
              data: JSON.stringify({
                status: $(this).prop("checked")
              }),
              headers: {
                'Content-Type': 'application/json',
                'X-CSRF-Token': token,
              },
              dataType: 'json',
              type: 'POST',
              contentType: 'application/json',
              success: function(data) {
                if (data.status == 1) {
                  $(".operator-status").removeClass('ms-status-online');
                  $(".operator-status").addClass('ms-status-busy');
                }
                else if (data.status == 0) {
                  $(".operator-status").addClass('ms-status-online');
                  $(".operator-status").removeClass('ms-status-busy');
                }
                $(".operator-status-txt").html($(".change-chat-status[data-status='" + data.status + "'] span").html());
              }
            });
          },
        );
      });

      $("#chat-msg-text").keypress(function (e) {
        if (e.which == 13) {
          e.preventDefault();
          var data = {
            "chat_id": $("#msgs-wrapper").data("chat_id")
          };
          sendMsg(data);
          $(this).val('');
        }
        if ((e.which == 10 || e.which == 13) && e.ctrlKey) {
          var val = $(this).val();
          $(this).val(val + "\r\n").focus().setSelectionRange($(this).value.length,$(this).value.length);
        }
      });

      Drupal.behaviors.chat.refreshChatsList();
      Drupal.behaviors.chat.bindChatSelectEvents();

      function sendMsg(data = {}) {
        sessionToken = Drupal.behaviors.chat.token();
        data.msg = $("#chat-msg-text").val();
        sessionToken.then(
          token => {
            $.ajax('/rest/chat?op=send-msg', {
              data: JSON.stringify(data),
              headers: {
                'Content-Type': 'application/json',
                'X-CSRF-Token': token,
              },
              dataType: 'json',
              type: 'POST',
              contentType: 'application/json',
              success: function(data) {
                console.log(data);
              }
            });
          },
        );
      }
    },
    showChat: function (id) {
      sessionToken = Drupal.behaviors.chat.token();

      sessionToken.then(
        token => {
          $.ajax('/rest/chat?op=show-chat', {
            headers: {
              'Content-Type': 'application/json',
              'X-CSRF-Token': token,
            },
            data: JSON.stringify({
              id: id
            }),
            dataType: 'json',
            type: 'POST',
            contentType: 'application/json',
            success: function(data) {
              var user_name;
              if (data.client_id)
                user_name = '<a href="/node/' + data.client_id + '" target="_blank">' + data.user_name + '</a>';
              else
                user_name = data.user_name;
              $("#chat-user-name").html(user_name);
              //
              $("#msgs-wrapper").html('');
              $("#msgs-wrapper").data("chat_id", id);
              $("#operator-name span").html(data.operator);
              $("#chat-msg-text").removeAttr("disabled");
              Drupal.behaviors.chat.appendMessagesClient(data);
              if (data.operator_id == 0 || data.operator_id == '') {
                var msg_tpl = $("#chat-msg-tpl-left").clone();
                var msg = msg_tpl.clone();
                msg.removeAttr("id");
                msg.show();
                msg.find(".text").html(Drupal.t('The first available specialist will answer you.'));
                $("#msgs-wrapper").append($(msg).get(0));
              }
            }
          });
        },
      );
    },
    bindChatSelectEvents: function () {
      $("#chats-list > div").each(function(el){
        $(this).unbind('click');
        $(this).click(function() {
          $("#chat-input").removeClass("hidden");
          $("#close-chat-btn, #pass-chat-btn").show();
          Drupal.behaviors.chat.showChat($(this).data('chat_id'));
          $("#switch-operator-wrapper").hide();
          $("#pass-chat-btn").show();
        });
      });
    },
    token: function () {
      let sessionToken = new Promise((resolve, reject) => {
        $.ajax({
          url: '/session/token',
          dataType: 'text',
          type: 'GET',
          success: response => {
            resolve(response);
          },
          error: response => {
            reject(response);
          },
        });
      });
      return sessionToken;
    },
    refreshChatsList: function () {
      sessionToken = Drupal.behaviors.chat.token();

      sessionToken.then(
        token => {
          $.ajax('/rest/chat?op=refresh-chats-list', {
            headers: {
              'Content-Type': 'application/json',
              'X-CSRF-Token': token,
            },
            dataType: 'json',
            type: 'POST',
            contentType: 'application/json',
            success: function(data) {
              var chat_list_el = $("#chats-list");
              chat_list_el.html('');
              if (data.chats.length > 0) {
                for (var i = 0; i < data.chats.length; i++) {
                  var chat = data.chats[i];
                  $(".operator-status img").attr("src", $(".ms-logo-img-link img").attr("src"));
                  var msg = chat['msg'];
                  var chat_list_item = `<div data-chat_id="${chat['chat_nid']}" class="nav-link text-start mw-100 p-3 active">
                <div class="row align-items-center flex-fill">
                  <div class="col-auto"><span class="avatar" style="background-image: url(./static/avatars/000m.jpg)"></span>
                  </div>
                  <div class="col text-body">
                    <div>${chat['user_name']}</div>
                    <div>${chat['display_time']}</div>
                    <div class="text-secondary text-truncate w-100">${msg}</div>
                  </div>
                </div>
              </div>`;
                  chat_list_el.append(chat_list_item);
                }
              }
              else {
                chat_list_el.html('<div class="card-body">' + Drupal.t('No chats') + '</div>');
              }
              Drupal.behaviors.chat.bindChatSelectEvents();
            }
          });
        },
      );
    },
    appendMessagesClient: function (data) {
      var msg_tpl_right = $("#chat-msg-tpl-right").clone();
      var msg_tpl_left = $("#chat-msg-tpl-left").clone();
      console.log(data);
      $.each(data.msgs, function(i, v) {
        var chat_list_length = $("#chats-list").length;
        if (chat_list_length > 0 && v.chat_id == $("#msgs-wrapper").data("chat_id") || chat_list_length == 0) {
          var msg;
          if (v.type == 'out') {
            msg = msg_tpl_right.clone();
          }
          else {
            msg = msg_tpl_left.clone();
          }
          msg.find(".chat-bubble-author").html(v.user_name);

          msg.removeAttr("id");
          msg.show();
          msg.find(".chat-bubble-body").html(v.msg.replace(/\n/g,"<br>"));
          msg.find(".chat-bubble-date").html(v.time);

          $("#msgs-wrapper").append($(msg).get(0));
          $("#operator-name span").html(v.operator);
        }
      });
      $(".card-body-chat").animate({ scrollTop: $('#msgs-wrapper').prop("scrollHeight")}, 1000);
    }
  };
})(jQuery, Drupal);
